package com.chinaitop.depot.intelligent.IntelligentDetection.model;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TTimingTaskHistoryExample {
    /**
     * t_timing_task_history
     */
    protected String orderByClause;

    /**
     * t_timing_task_history
     */
    protected boolean distinct;

    /**
     * t_timing_task_history
     */
    protected List<Criteria> oredCriteria;

    public TTimingTaskHistoryExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * t_timing_task_history 2019-05-21
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNull() {
            addCriterion("org_id is null");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNotNull() {
            addCriterion("org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrgIdEqualTo(String value) {
            addCriterion("org_id =", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotEqualTo(String value) {
            addCriterion("org_id <>", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThan(String value) {
            addCriterion("org_id >", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThanOrEqualTo(String value) {
            addCriterion("org_id >=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThan(String value) {
            addCriterion("org_id <", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThanOrEqualTo(String value) {
            addCriterion("org_id <=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLike(String value) {
            addCriterion("org_id like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotLike(String value) {
            addCriterion("org_id not like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdIn(List<String> values) {
            addCriterion("org_id in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotIn(List<String> values) {
            addCriterion("org_id not in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdBetween(String value1, String value2) {
            addCriterion("org_id between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotBetween(String value1, String value2) {
            addCriterion("org_id not between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andTIdIsNull() {
            addCriterion("t_id is null");
            return (Criteria) this;
        }

        public Criteria andTIdIsNotNull() {
            addCriterion("t_id is not null");
            return (Criteria) this;
        }

        public Criteria andTIdEqualTo(String value) {
            addCriterion("t_id =", value, "tId");
            return (Criteria) this;
        }

        public Criteria andTIdNotEqualTo(String value) {
            addCriterion("t_id <>", value, "tId");
            return (Criteria) this;
        }

        public Criteria andTIdGreaterThan(String value) {
            addCriterion("t_id >", value, "tId");
            return (Criteria) this;
        }

        public Criteria andTIdGreaterThanOrEqualTo(String value) {
            addCriterion("t_id >=", value, "tId");
            return (Criteria) this;
        }

        public Criteria andTIdLessThan(String value) {
            addCriterion("t_id <", value, "tId");
            return (Criteria) this;
        }

        public Criteria andTIdLessThanOrEqualTo(String value) {
            addCriterion("t_id <=", value, "tId");
            return (Criteria) this;
        }

        public Criteria andTIdLike(String value) {
            addCriterion("t_id like", value, "tId");
            return (Criteria) this;
        }

        public Criteria andTIdNotLike(String value) {
            addCriterion("t_id not like", value, "tId");
            return (Criteria) this;
        }

        public Criteria andTIdIn(List<String> values) {
            addCriterion("t_id in", values, "tId");
            return (Criteria) this;
        }

        public Criteria andTIdNotIn(List<String> values) {
            addCriterion("t_id not in", values, "tId");
            return (Criteria) this;
        }

        public Criteria andTIdBetween(String value1, String value2) {
            addCriterion("t_id between", value1, value2, "tId");
            return (Criteria) this;
        }

        public Criteria andTIdNotBetween(String value1, String value2) {
            addCriterion("t_id not between", value1, value2, "tId");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIsNull() {
            addCriterion("v_cf_code is null");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIsNotNull() {
            addCriterion("v_cf_code is not null");
            return (Criteria) this;
        }

        public Criteria andVCfCodeEqualTo(String value) {
            addCriterion("v_cf_code =", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotEqualTo(String value) {
            addCriterion("v_cf_code <>", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeGreaterThan(String value) {
            addCriterion("v_cf_code >", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeGreaterThanOrEqualTo(String value) {
            addCriterion("v_cf_code >=", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLessThan(String value) {
            addCriterion("v_cf_code <", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLessThanOrEqualTo(String value) {
            addCriterion("v_cf_code <=", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLike(String value) {
            addCriterion("v_cf_code like", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotLike(String value) {
            addCriterion("v_cf_code not like", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIn(List<String> values) {
            addCriterion("v_cf_code in", values, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotIn(List<String> values) {
            addCriterion("v_cf_code not in", values, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeBetween(String value1, String value2) {
            addCriterion("v_cf_code between", value1, value2, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotBetween(String value1, String value2) {
            addCriterion("v_cf_code not between", value1, value2, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andTDetectionDescIsNull() {
            addCriterion("t_detection_desc is null");
            return (Criteria) this;
        }

        public Criteria andTDetectionDescIsNotNull() {
            addCriterion("t_detection_desc is not null");
            return (Criteria) this;
        }

        public Criteria andTDetectionDescEqualTo(String value) {
            addCriterion("t_detection_desc =", value, "tDetectionDesc");
            return (Criteria) this;
        }

        public Criteria andTDetectionDescNotEqualTo(String value) {
            addCriterion("t_detection_desc <>", value, "tDetectionDesc");
            return (Criteria) this;
        }

        public Criteria andTDetectionDescGreaterThan(String value) {
            addCriterion("t_detection_desc >", value, "tDetectionDesc");
            return (Criteria) this;
        }

        public Criteria andTDetectionDescGreaterThanOrEqualTo(String value) {
            addCriterion("t_detection_desc >=", value, "tDetectionDesc");
            return (Criteria) this;
        }

        public Criteria andTDetectionDescLessThan(String value) {
            addCriterion("t_detection_desc <", value, "tDetectionDesc");
            return (Criteria) this;
        }

        public Criteria andTDetectionDescLessThanOrEqualTo(String value) {
            addCriterion("t_detection_desc <=", value, "tDetectionDesc");
            return (Criteria) this;
        }

        public Criteria andTDetectionDescLike(String value) {
            addCriterion("t_detection_desc like", value, "tDetectionDesc");
            return (Criteria) this;
        }

        public Criteria andTDetectionDescNotLike(String value) {
            addCriterion("t_detection_desc not like", value, "tDetectionDesc");
            return (Criteria) this;
        }

        public Criteria andTDetectionDescIn(List<String> values) {
            addCriterion("t_detection_desc in", values, "tDetectionDesc");
            return (Criteria) this;
        }

        public Criteria andTDetectionDescNotIn(List<String> values) {
            addCriterion("t_detection_desc not in", values, "tDetectionDesc");
            return (Criteria) this;
        }

        public Criteria andTDetectionDescBetween(String value1, String value2) {
            addCriterion("t_detection_desc between", value1, value2, "tDetectionDesc");
            return (Criteria) this;
        }

        public Criteria andTDetectionDescNotBetween(String value1, String value2) {
            addCriterion("t_detection_desc not between", value1, value2, "tDetectionDesc");
            return (Criteria) this;
        }

        public Criteria andTDetectionCronIsNull() {
            addCriterion("t_detection_cron is null");
            return (Criteria) this;
        }

        public Criteria andTDetectionCronIsNotNull() {
            addCriterion("t_detection_cron is not null");
            return (Criteria) this;
        }

        public Criteria andTDetectionCronEqualTo(String value) {
            addCriterion("t_detection_cron =", value, "tDetectionCron");
            return (Criteria) this;
        }

        public Criteria andTDetectionCronNotEqualTo(String value) {
            addCriterion("t_detection_cron <>", value, "tDetectionCron");
            return (Criteria) this;
        }

        public Criteria andTDetectionCronGreaterThan(String value) {
            addCriterion("t_detection_cron >", value, "tDetectionCron");
            return (Criteria) this;
        }

        public Criteria andTDetectionCronGreaterThanOrEqualTo(String value) {
            addCriterion("t_detection_cron >=", value, "tDetectionCron");
            return (Criteria) this;
        }

        public Criteria andTDetectionCronLessThan(String value) {
            addCriterion("t_detection_cron <", value, "tDetectionCron");
            return (Criteria) this;
        }

        public Criteria andTDetectionCronLessThanOrEqualTo(String value) {
            addCriterion("t_detection_cron <=", value, "tDetectionCron");
            return (Criteria) this;
        }

        public Criteria andTDetectionCronLike(String value) {
            addCriterion("t_detection_cron like", value, "tDetectionCron");
            return (Criteria) this;
        }

        public Criteria andTDetectionCronNotLike(String value) {
            addCriterion("t_detection_cron not like", value, "tDetectionCron");
            return (Criteria) this;
        }

        public Criteria andTDetectionCronIn(List<String> values) {
            addCriterion("t_detection_cron in", values, "tDetectionCron");
            return (Criteria) this;
        }

        public Criteria andTDetectionCronNotIn(List<String> values) {
            addCriterion("t_detection_cron not in", values, "tDetectionCron");
            return (Criteria) this;
        }

        public Criteria andTDetectionCronBetween(String value1, String value2) {
            addCriterion("t_detection_cron between", value1, value2, "tDetectionCron");
            return (Criteria) this;
        }

        public Criteria andTDetectionCronNotBetween(String value1, String value2) {
            addCriterion("t_detection_cron not between", value1, value2, "tDetectionCron");
            return (Criteria) this;
        }

        public Criteria andTCategoryIsNull() {
            addCriterion("t_category is null");
            return (Criteria) this;
        }

        public Criteria andTCategoryIsNotNull() {
            addCriterion("t_category is not null");
            return (Criteria) this;
        }

        public Criteria andTCategoryEqualTo(String value) {
            addCriterion("t_category =", value, "tCategory");
            return (Criteria) this;
        }

        public Criteria andTCategoryNotEqualTo(String value) {
            addCriterion("t_category <>", value, "tCategory");
            return (Criteria) this;
        }

        public Criteria andTCategoryGreaterThan(String value) {
            addCriterion("t_category >", value, "tCategory");
            return (Criteria) this;
        }

        public Criteria andTCategoryGreaterThanOrEqualTo(String value) {
            addCriterion("t_category >=", value, "tCategory");
            return (Criteria) this;
        }

        public Criteria andTCategoryLessThan(String value) {
            addCriterion("t_category <", value, "tCategory");
            return (Criteria) this;
        }

        public Criteria andTCategoryLessThanOrEqualTo(String value) {
            addCriterion("t_category <=", value, "tCategory");
            return (Criteria) this;
        }

        public Criteria andTCategoryLike(String value) {
            addCriterion("t_category like", value, "tCategory");
            return (Criteria) this;
        }

        public Criteria andTCategoryNotLike(String value) {
            addCriterion("t_category not like", value, "tCategory");
            return (Criteria) this;
        }

        public Criteria andTCategoryIn(List<String> values) {
            addCriterion("t_category in", values, "tCategory");
            return (Criteria) this;
        }

        public Criteria andTCategoryNotIn(List<String> values) {
            addCriterion("t_category not in", values, "tCategory");
            return (Criteria) this;
        }

        public Criteria andTCategoryBetween(String value1, String value2) {
            addCriterion("t_category between", value1, value2, "tCategory");
            return (Criteria) this;
        }

        public Criteria andTCategoryNotBetween(String value1, String value2) {
            addCriterion("t_category not between", value1, value2, "tCategory");
            return (Criteria) this;
        }

        public Criteria andTUpdateTimeIsNull() {
            addCriterion("t_update_time is null");
            return (Criteria) this;
        }

        public Criteria andTUpdateTimeIsNotNull() {
            addCriterion("t_update_time is not null");
            return (Criteria) this;
        }

        public Criteria andTUpdateTimeEqualTo(Date value) {
            addCriterion("t_update_time =", value, "tUpdateTime");
            return (Criteria) this;
        }

        public Criteria andTUpdateTimeNotEqualTo(Date value) {
            addCriterion("t_update_time <>", value, "tUpdateTime");
            return (Criteria) this;
        }

        public Criteria andTUpdateTimeGreaterThan(Date value) {
            addCriterion("t_update_time >", value, "tUpdateTime");
            return (Criteria) this;
        }

        public Criteria andTUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("t_update_time >=", value, "tUpdateTime");
            return (Criteria) this;
        }

        public Criteria andTUpdateTimeLessThan(Date value) {
            addCriterion("t_update_time <", value, "tUpdateTime");
            return (Criteria) this;
        }

        public Criteria andTUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("t_update_time <=", value, "tUpdateTime");
            return (Criteria) this;
        }

        public Criteria andTUpdateTimeIn(List<Date> values) {
            addCriterion("t_update_time in", values, "tUpdateTime");
            return (Criteria) this;
        }

        public Criteria andTUpdateTimeNotIn(List<Date> values) {
            addCriterion("t_update_time not in", values, "tUpdateTime");
            return (Criteria) this;
        }

        public Criteria andTUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("t_update_time between", value1, value2, "tUpdateTime");
            return (Criteria) this;
        }

        public Criteria andTUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("t_update_time not between", value1, value2, "tUpdateTime");
            return (Criteria) this;
        }

        public Criteria andTRemarkIsNull() {
            addCriterion("t_remark is null");
            return (Criteria) this;
        }

        public Criteria andTRemarkIsNotNull() {
            addCriterion("t_remark is not null");
            return (Criteria) this;
        }

        public Criteria andTRemarkEqualTo(String value) {
            addCriterion("t_remark =", value, "tRemark");
            return (Criteria) this;
        }

        public Criteria andTRemarkNotEqualTo(String value) {
            addCriterion("t_remark <>", value, "tRemark");
            return (Criteria) this;
        }

        public Criteria andTRemarkGreaterThan(String value) {
            addCriterion("t_remark >", value, "tRemark");
            return (Criteria) this;
        }

        public Criteria andTRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("t_remark >=", value, "tRemark");
            return (Criteria) this;
        }

        public Criteria andTRemarkLessThan(String value) {
            addCriterion("t_remark <", value, "tRemark");
            return (Criteria) this;
        }

        public Criteria andTRemarkLessThanOrEqualTo(String value) {
            addCriterion("t_remark <=", value, "tRemark");
            return (Criteria) this;
        }

        public Criteria andTRemarkLike(String value) {
            addCriterion("t_remark like", value, "tRemark");
            return (Criteria) this;
        }

        public Criteria andTRemarkNotLike(String value) {
            addCriterion("t_remark not like", value, "tRemark");
            return (Criteria) this;
        }

        public Criteria andTRemarkIn(List<String> values) {
            addCriterion("t_remark in", values, "tRemark");
            return (Criteria) this;
        }

        public Criteria andTRemarkNotIn(List<String> values) {
            addCriterion("t_remark not in", values, "tRemark");
            return (Criteria) this;
        }

        public Criteria andTRemarkBetween(String value1, String value2) {
            addCriterion("t_remark between", value1, value2, "tRemark");
            return (Criteria) this;
        }

        public Criteria andTRemarkNotBetween(String value1, String value2) {
            addCriterion("t_remark not between", value1, value2, "tRemark");
            return (Criteria) this;
        }
    }

    /**
     * t_timing_task_history
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * t_timing_task_history 2019-05-21
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}